/* Source code released into the public domain 05-03-97
 Please feel free to improve on this work, Just give me credit
 'Jovis' for the base code. This is for the overall betterment of
 the n64 scene, as we all know it is beginning to kick some 
 major ass. I would suggest that we all donate our knowledge in
 this way, to help everyone and get some really kick-ass stuff,
 rather than squabble over who made what first :).
 BTW i will be moving on to bios-upgrades and possibly hardware
 mods to your doctor to make a realtime tracer/debugger/development
 tool we can all use! Have fun with this, and give your knowledge
 freely too!!! :)
 */

// disasmDoc.h : interface of the CDisasmDoc class
//
/////////////////////////////////////////////////////////////////////////////
#ifndef little_endian
#define little_endian 1
#define big_endian 0
#define not_flipped 0
#define flipped 1
#endif

class COffsetDlg;



class CDisasmDoc : public CDocument
{
protected: // create from serialization only
	CDisasmDoc();
	DECLARE_DYNCREATE(CDisasmDoc)

// Attributes
public:
	COffsetDlg *offset_dlg_handle;
	int Code_Extract;
	BYTE byte_order;
	BYTE byte_end;
	LPSTR romhandle;
	DWORD current_rom_position;//in lines==4 bytes
	DWORD romsize;
	LPSTR GetData(DWORD);
	BYTE GetByte(DWORD);


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDisasmDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDisasmDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CDisasmDoc)
	afx_msg void OnByteorderingBigEndian();
	afx_msg void OnByteorderingFlipbyteswithinwords();
	afx_msg void OnByteorderingLittleendian();
	afx_msg void OnUpdateByteorderingBigEndian(CCmdUI* pCmdUI);
	afx_msg void OnUpdateByteorderingFlipbyteswithinwords(CCmdUI* pCmdUI);
	afx_msg void OnUpdateByteorderingLittleendian(CCmdUI* pCmdUI);
	afx_msg void OnDataextractionActive();
	afx_msg void OnUpdateDataextractionActive(CCmdUI* pCmdUI);
	afx_msg void OnViewGotooffset();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
