// disasmView.cpp : implementation of the CDisasmView class
//

#include "stdafx.h"
#include "disasm.h"

#include "disasmDoc.h"
#include "disasmView.h"
#include <iostream.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDisasmView

IMPLEMENT_DYNCREATE(CDisasmView, CView)

BEGIN_MESSAGE_MAP(CDisasmView, CView)
	//{{AFX_MSG_MAP(CDisasmView)
	ON_COMMAND(ID_FORMAT_DISASSEMBLY, OnFormatDisassembly)
	ON_WM_VSCROLL()
	ON_COMMAND(ID_FORMAT_RAWASCII, OnFormatRawascii)
	ON_COMMAND(ID_FORMAT_IMAGE_16BITSPIXEL1OF65536COLORS, OnFormatImage16bitspixel1of65536colors)
	ON_COMMAND(ID_FORMAT_IMAGE_8BITSPIXEL, OnFormatImage8bitspixel)
	ON_UPDATE_COMMAND_UI(ID_FORMAT_IMAGE_16BITSPIXEL1OF65536COLORS, OnUpdateFormatImage16bitspixel1of65536colors)
	ON_UPDATE_COMMAND_UI(ID_FORMAT_IMAGE_8BITSPIXEL, OnUpdateFormatImage8bitspixel)
	ON_UPDATE_COMMAND_UI(ID_FORMAT_RAWASCII, OnUpdateFormatRawascii)
	ON_UPDATE_COMMAND_UI(ID_FORMAT_DISASSEMBLY, OnUpdateFormatDisassembly)
	ON_COMMAND(ID_FORMAT_IMAGE_24BITSPIXEL1BYTERGB, OnFormatImage24bitspixel1bytergb)
	ON_UPDATE_COMMAND_UI(ID_FORMAT_IMAGE_24BITSPIXEL1BYTERGB, OnUpdateFormatImage24bitspixel1bytergb)
	ON_COMMAND(ID_FORMAT_IMAGE_15BITSPIXEL5BITRGBUNPACKED, OnFormatImage15bitspixel5bitrgbunpacked)
	ON_UPDATE_COMMAND_UI(ID_FORMAT_IMAGE_15BITSPIXEL5BITRGBUNPACKED, OnUpdateFormatImage15bitspixel5bitrgbunpacked)
	ON_COMMAND(ID_FORMAT_IMAGE_18BITSPIXEL6BITRGBUNPACKED, OnFormatImage18bitspixel6bitrgbunpacked)
	ON_UPDATE_COMMAND_UI(ID_FORMAT_IMAGE_18BITSPIXEL6BITRGBUNPACKED, OnUpdateFormatImage18bitspixel6bitrgbunpacked)
	ON_COMMAND(ID_FORMAT_IMAGE_21BITSPIXEL7BITRGBUNPACKED, OnFormatImage21bitspixel7bitrgbunpacked)
	ON_UPDATE_COMMAND_UI(ID_FORMAT_IMAGE_21BITSPIXEL7BITRGBUNPACKED, OnUpdateFormatImage21bitspixel7bitrgbunpacked)
	ON_COMMAND(ID_FORMAT_RAWHEX, OnFormatRawhex)
	ON_UPDATE_COMMAND_UI(ID_FORMAT_RAWHEX, OnUpdateFormatRawhex)
	ON_COMMAND(ID_FORMAT_IMAGE_15BITPACKEDRGBN64UNCOMPRESSED, OnFormatImage15bitpackedrgbn64uncompressed)
	ON_UPDATE_COMMAND_UI(ID_FORMAT_IMAGE_15BITPACKEDRGBN64UNCOMPRESSED, OnUpdateFormatImage15bitpackedrgbn64uncompressed)
	ON_COMMAND(ID_FORMAT_ZOOM_1X, OnFormatZoom1x)
	ON_UPDATE_COMMAND_UI(ID_FORMAT_ZOOM_1X, OnUpdateFormatZoom1x)
	ON_COMMAND(ID_FORMAT_ZOOM_2X, OnFormatZoom2x)
	ON_UPDATE_COMMAND_UI(ID_FORMAT_ZOOM_2X, OnUpdateFormatZoom2x)
	ON_COMMAND(ID_FORMAT_ZOOM_4X, OnFormatZoom4x)
	ON_UPDATE_COMMAND_UI(ID_FORMAT_ZOOM_4X, OnUpdateFormatZoom4x)
	ON_COMMAND(ID_FORMAT_ZOOM_8X, OnFormatZoom8x)
	ON_UPDATE_COMMAND_UI(ID_FORMAT_ZOOM_8X, OnUpdateFormatZoom8x)
	ON_COMMAND(ID_SOUND_PLAY, OnSoundPlay)
	ON_COMMAND(ID_SOUND_22KHZ, OnSound22khz)
	ON_UPDATE_COMMAND_UI(ID_SOUND_22KHZ, OnUpdateSound22khz)
	ON_COMMAND(ID_SOUND_11KHZ, OnSound11khz)
	ON_UPDATE_COMMAND_UI(ID_SOUND_11KHZ, OnUpdateSound11khz)
	ON_COMMAND(ID_SOUND_44KHZ, OnSound44khz)
	ON_UPDATE_COMMAND_UI(ID_SOUND_44KHZ, OnUpdateSound44khz)
	ON_COMMAND(ID_SOUND_MONO, OnSoundMono)
	ON_UPDATE_COMMAND_UI(ID_SOUND_MONO, OnUpdateSoundMono)
	ON_COMMAND(ID_SOUND_STEREO, OnSoundStereo)
	ON_UPDATE_COMMAND_UI(ID_SOUND_STEREO, OnUpdateSoundStereo)
	ON_COMMAND(ID_SOUND_PLAYLENGTH_100000SAMPLES, OnSoundPlaylength100000samples)
	ON_UPDATE_COMMAND_UI(ID_SOUND_PLAYLENGTH_100000SAMPLES, OnUpdateSoundPlaylength100000samples)
	ON_COMMAND(ID_SOUND_PLAYLENGTH_10000SAMPLES, OnSoundPlaylength10000samples)
	ON_UPDATE_COMMAND_UI(ID_SOUND_PLAYLENGTH_10000SAMPLES, OnUpdateSoundPlaylength10000samples)
	ON_COMMAND(ID_SOUND_PLAYLENGTH_1MSAMPLES, OnSoundPlaylength1msamples)
	ON_UPDATE_COMMAND_UI(ID_SOUND_PLAYLENGTH_1MSAMPLES, OnUpdateSoundPlaylength1msamples)
	ON_COMMAND(ID_SOUND_BITSPERSAMPLE_8, OnSoundBitspersample8)
	ON_UPDATE_COMMAND_UI(ID_SOUND_BITSPERSAMPLE_8, OnUpdateSoundBitspersample8)
	ON_COMMAND(ID_SOUND_BITSPERSAMPLE_16, OnSoundBitspersample16)
	ON_UPDATE_COMMAND_UI(ID_SOUND_BITSPERSAMPLE_16, OnUpdateSoundBitspersample16)
	ON_COMMAND(ID_SOUND_SIGNEDUNSIGNEDWRAP, OnSoundSignedunsignedwrap)
	ON_UPDATE_COMMAND_UI(ID_SOUND_SIGNEDUNSIGNEDWRAP, OnUpdateSoundSignedunsignedwrap)
	ON_COMMAND(ID_FORMAT_WAVEFORM, OnFormatWaveform)
	ON_UPDATE_COMMAND_UI(ID_FORMAT_WAVEFORM, OnUpdateFormatWaveform)
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDisasmView construction/destruction

CDisasmView::CDisasmView()
{
	view_type=view_disasm;
	zoomfactor=1;
	sound_rate=8000;

	sound_length=10000;
	sound_channels=1;
	sound_bitsperchannel=8;
	sound_signed=1;

	


}

CDisasmView::~CDisasmView()
{

}

BOOL CDisasmView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	cs.style|=WS_VSCROLL;
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDisasmView drawing

void CDisasmView::OnDraw(CDC* pDC)
{
	CDisasmDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	int num_lines,x;
	DWORD xbytes,ybytes,xpos,ypos,xrompos,yrompos,xpixels,ypixels;
	CRect rect;
	BYTE databyte,databyte1,databyte2;
	LPSTR string;
	
	SCROLLINFO myscroll;

	ypos=0;
	xpos=0;
	yrompos=0;
	xrompos=0;


	myscroll.fMask=(SIF_PAGE|SIF_RANGE|SIF_POS);
	myscroll.nMin=0;
	myscroll.nMax=pDoc->romsize;
	myscroll.nPage=1;
	myscroll.nPos=pDoc->current_rom_position*4;

	SetScrollInfo(SB_VERT,&myscroll,TRUE);

if(view_type==view_waveform)
{
			GetClientRect(&rect);

			xpixels=(rect.right-rect.left);
			ypixels=(rect.bottom-rect.top);

			

			for(xpos=0;(xpos<xpixels)&&(xpos+pDoc->current_rom_position<pDoc->romsize);xpos++)
			{
				ypos=(ypixels*(pDoc->GetByte(xpos)))/256;
	
				pDC->SetPixel(xpos,ypos,RGB(0,0,0));
			}
return;
}










	if(view_type==view_ascii)
	{
		GetClientRect(&rect);
		pDC->SetTextAlign(TA_LEFT);

		xbytes=(rect.right-rect.left)/13;
		ybytes=(rect.bottom-rect.top)/17;


		
		ypos=0;
		xpos=0;
		string=new char[25];

		
		for(ypos=0;ypos<ybytes;ypos++)
			for(xpos=0;xpos<xbytes;xpos++)
			{
				if(((DWORD)(xpos+(pDoc->current_rom_position*4))+(ypos*xbytes))<(pDoc->romsize))
				{
					databyte=pDoc->GetByte(xpos+(ypos*xbytes));
					sprintf(string,"%c",databyte);
					pDC->TextOut(xpos*13,ypos*17,string,strlen(string));
				}
			}
		delete [] string;
		return;
		

	}
	else
	if(view_type==view_image)
	{
			GetClientRect(&rect);

			xbytes=(rect.right-rect.left)/zoomfactor;
			ybytes=(rect.bottom-rect.top)/zoomfactor;

			xpixels=(rect.right-rect.left);
			ypixels=(rect.bottom-rect.top);

		if(image_type==image_8bit)
		for(ypos=0;ypos<ypixels;ypos++)
		{
			for(xpos=0;xpos<xpixels;xpos++)
			{
			if(((DWORD)(xrompos+(pDoc->current_rom_position*4))+(yrompos*xbytes))<(pDoc->romsize))
				{
				xrompos=xpos/zoomfactor;
				yrompos=ypos/zoomfactor;
				
				
					databyte=pDoc->GetByte(xrompos+(yrompos*xbytes));
				
					pDC->SetPixel(xpos,ypos,PALETTEINDEX(databyte));
				
				}
			}
		
		}
		if(image_type==image_16bit)
		for(ypos=0;ypos<ypixels;ypos++)
			for(xpos=0;xpos<xpixels;xpos++)
			{
			if(((DWORD)((xrompos*2)+(pDoc->current_rom_position*4))+(yrompos*xbytes*2))<(pDoc->romsize))
				{
				xrompos=xpos/zoomfactor;
				yrompos=ypos/zoomfactor;
				
					databyte=pDoc->GetByte((xrompos*2)+(yrompos*xbytes*2));
					databyte1=pDoc->GetByte((xrompos*2)+(yrompos*xbytes*2)+1);
					pDC->SetPixel(xpos,ypos,PALETTEINDEX(((((WORD)databyte)<<8)|databyte1)));
				}
			}
		if(image_type==image_15bitpacked)
		for(ypos=0;ypos<ypixels;ypos++)
			for(xpos=0;xpos<xpixels;xpos++)
			{
			if(((DWORD)((xrompos*2)+(pDoc->current_rom_position*4))+(yrompos*xbytes*2))<(pDoc->romsize))
				{
				xrompos=xpos/zoomfactor;
				yrompos=ypos/zoomfactor;
				
					databyte=pDoc->GetByte((xrompos*2)+(yrompos*xbytes*2));
					databyte1=pDoc->GetByte((xrompos*2)+(yrompos*xbytes*2)+1);

					pDC->SetPixel(xpos,ypos,PALETTERGB(((databyte&0x7c)>>2)*(0xff/0x1f),((((databyte&0x3)<<3)|((databyte1&0xe0)>>5)))*(0xff/0x1f),(databyte1&0x1f)*(0xff/0x1f)));
				}
			}
		if(image_type==image_24bit)
		for(ypos=0;ypos<ypixels;ypos++)
			for(xpos=0;xpos<xpixels;xpos++)
			{
			if(((DWORD)((xrompos*3)+(pDoc->current_rom_position*4))+(yrompos*xbytes*3))<(pDoc->romsize))
				{
				xrompos=xpos/zoomfactor;
				yrompos=ypos/zoomfactor;
				
					databyte=pDoc->GetByte((xrompos*3)+(yrompos*xbytes*3));
					databyte1=pDoc->GetByte((xrompos*3)+(yrompos*xbytes*3)+1);
					databyte2=pDoc->GetByte((xrompos*3)+(yrompos*xbytes*3)+2);
				
					pDC->SetPixel(xpos,ypos,RGB(databyte,databyte1,databyte2));
				}
			}
		if(image_type==image_15bit)
		for(ypos=0;ypos<ypixels;ypos++)
			for(xpos=0;xpos<xpixels;xpos++)
			{
			if(((DWORD)((xrompos*3)+(pDoc->current_rom_position*4))+(yrompos*xbytes*3))<(pDoc->romsize))
				{
				xrompos=xpos/zoomfactor;
				yrompos=ypos/zoomfactor;
				
					databyte=pDoc->GetByte((xrompos*3)+(yrompos*xbytes*3));
					databyte1=pDoc->GetByte((xrompos*3)+(yrompos*xbytes*3)+1);
					databyte2=pDoc->GetByte((xrompos*3)+(yrompos*xbytes*3)+2);
				
					pDC->SetPixel(xpos,ypos,RGB(databyte&0xe0,databyte1&0xe0,databyte2&0xe0));
				}
			}
		if(image_type==image_18bit)
		for(ypos=0;ypos<ypixels;ypos++)
			for(xpos=0;xpos<xpixels;xpos++)
			{
			if(((DWORD)((xrompos*3)+(pDoc->current_rom_position*4))+(yrompos*xbytes*3))<(pDoc->romsize))
				{
				xrompos=xpos/zoomfactor;
				yrompos=ypos/zoomfactor;
				
					databyte=pDoc->GetByte((xrompos*3)+(yrompos*xbytes*3));
					databyte1=pDoc->GetByte((xrompos*3)+(yrompos*xbytes*3)+1);
					databyte2=pDoc->GetByte((xrompos*3)+(yrompos*xbytes*3)+2);
				
					pDC->SetPixel(xpos,ypos,RGB(databyte&0xc0,databyte1&0xc0,databyte2&0xc0));
				}
			}
		if(image_type==image_21bit)
		for(ypos=0;ypos<ypixels;ypos++)
			for(xpos=0;xpos<xpixels;xpos++)
			{
			if(((DWORD)((xrompos*3)+(pDoc->current_rom_position*4))+(yrompos*xbytes*3))<(pDoc->romsize))
				{
				xrompos=xpos/zoomfactor;
				yrompos=ypos/zoomfactor;
				
					databyte=pDoc->GetByte((xrompos*3)+(yrompos*xbytes*3));
					databyte1=pDoc->GetByte((xrompos*3)+(yrompos*xbytes*3)+1);
					databyte2=pDoc->GetByte((xrompos*3)+(yrompos*xbytes*3)+2);
				
					pDC->SetPixel(xpos,ypos,RGB(databyte&0x80,databyte1&0x80,databyte2&0x80));
				}
			}

	
	return;
	}
	else
	if(view_type==view_hex)
	{
		GetClientRect(&rect);
		pDC->SetTextAlign(TA_LEFT);

		xbytes=(rect.right-rect.left)/26;
		ybytes=(rect.bottom-rect.top)/17;
		
		ypos=0;
		xpos=0;
		string=new char[25];

		
		for(ypos=0;ypos<ybytes;ypos++)
			for(xpos=0;xpos<xbytes;xpos++)
			{
				if(((DWORD)(xpos+(pDoc->current_rom_position*4))+(ypos*ybytes))<(pDoc->romsize))
				{
					databyte=pDoc->GetByte(xpos+(ypos*xbytes));
					sprintf(string,"%X",databyte);
					pDC->TextOut(xpos*26,ypos*17,string,strlen(string));
				}
			}
		delete [] string;
		return;
		

	}






	


	CSize linesize,pagesize;

	


	GetClientRect(&rect);
	CSize size((rect.right-rect.left),(pDoc->romsize/4)*17);

	linesize.cx=1;
	linesize.cy=17;
	
	pagesize.cx=(rect.right-rect.left);
	pagesize.cy=(rect.bottom-rect.top);

//	SetScrollSizes(MM_TEXT,size,pagesize,linesize);
	num_lines=(rect.bottom-rect.top)/17;

	
	

	pDC->SetTextAlign(TA_LEFT);
	for(x=0;x<num_lines;x++)
	{
		string=0;

		if(!((x+pDoc->current_rom_position)>(pDoc->romsize/4)))
		string=pDoc->GetData(x+pDoc->current_rom_position);
		if(string)
		{
			pDC->TextOut(rect.left,rect.top+(x*17),string,strlen(string));
			delete [] string;
		}
	}



}

void CDisasmView::OnInitialUpdate()
{
	CView::OnInitialUpdate();
	CSize sizeTotal;


	// TODO: calculate the total size of this view
	sizeTotal.cx = sizeTotal.cy = 10000;

}

/////////////////////////////////////////////////////////////////////////////
// CDisasmView printing

BOOL CDisasmView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDisasmView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDisasmView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDisasmView diagnostics

#ifdef _DEBUG
void CDisasmView::AssertValid() const
{
	CView::AssertValid();
}

void CDisasmView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDisasmDoc* CDisasmView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDisasmDoc)));
	return (CDisasmDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDisasmView message handlers

void CDisasmView::OnFormatDisassembly() 
{	CDisasmDoc* pDoc = GetDocument();
	view_type=view_disasm;
		pDoc->UpdateAllViews(NULL);
}

void CDisasmView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{

	CDisasmDoc* pDoc = GetDocument();
	
	CRect rect;
		
	GetClientRect(&rect);

	switch(nSBCode)
	{
	case(SB_BOTTOM):
		{
			pDoc->current_rom_position=pDoc->romsize/4;
	
			break;
		}
	case(SB_TOP):
		{
			pDoc->current_rom_position=0;

			break;
		}
	case(SB_ENDSCROLL):
		{
			break;
		}
	case(SB_LINEDOWN):
		{if(pDoc->current_rom_position+((rect.bottom-rect.top)/17)<=(pDoc->romsize/4))
		{		if(view_type==view_ascii)
					pDoc->current_rom_position+=((rect.right-rect.left)/13)/4;
				else
			if(view_type==view_image)
			{
				if(image_type==image_8bit)
					pDoc->current_rom_position+=((rect.right-rect.left)*(rect.bottom-rect.top));
				else
				if(image_type==image_16bit)
					pDoc->current_rom_position+=((rect.right-rect.left)*2*(rect.bottom-rect.top));
				else
					pDoc->current_rom_position+=(rect.right-rect.left)*3*((rect.bottom-rect.top));

			}
			else
				pDoc->current_rom_position++;
		}
			break;
		}
	case(SB_LINEUP):
		{if(pDoc->current_rom_position>0)
		{	if(view_type==view_ascii)
				pDoc->current_rom_position-=((rect.right-rect.left)/13)/4;
			else
			if(view_type==view_image)
			{
				if(image_type==image_8bit)
					pDoc->current_rom_position-=(rect.right-rect.left)*((rect.bottom-rect.top)/4);
				else
				if(image_type==image_16bit)
					pDoc->current_rom_position-=(rect.right-rect.left)*2*((rect.bottom-rect.top)/4);
				else
					pDoc->current_rom_position-=(rect.right-rect.left)*3*((rect.bottom-rect.top)/4);

			}
			else
			pDoc->current_rom_position--;
		}
			break;
		}
	case(SB_PAGEDOWN):
		{if(pDoc->current_rom_position+((rect.bottom-rect.top)/17)<=(pDoc->romsize/4))
			{
			if(view_type==view_ascii)
				pDoc->current_rom_position+=(((rect.right-rect.left)/13)*((rect.bottom-rect.top)/17))/4;
			else
			if(view_type==view_image)
			{
				if(image_type==image_8bit)
					pDoc->current_rom_position+=(rect.bottom-rect.top)*(rect.right-rect.left);
				else
				if(image_type==image_16bit)
					pDoc->current_rom_position+=(rect.bottom-rect.top)*(rect.right-rect.left)*2;
				else
					pDoc->current_rom_position+=(rect.bottom-rect.top)*(rect.right-rect.left)*3;

			}
			else
			
			pDoc->current_rom_position+=(rect.bottom-rect.top)/17;
			}
	

			break;
		}
	case(SB_PAGEUP):
		{if(pDoc->current_rom_position>0)
			{
			if(view_type==view_ascii)
				pDoc->current_rom_position-=(((rect.right-rect.left)/13)*((rect.bottom-rect.top)/17))/4;
			else
			if(view_type==view_image)
			{
				if(image_type==image_8bit)
					pDoc->current_rom_position-=(rect.bottom-rect.top)*(rect.right-rect.left);
				else
				if(image_type==image_16bit)
					pDoc->current_rom_position-=(rect.bottom-rect.top)*(rect.right-rect.left)*2;
				else
					pDoc->current_rom_position-=(rect.bottom-rect.top)*(rect.right-rect.left)*3;

			}
			else
			
			pDoc->current_rom_position-=(rect.bottom-rect.top)/17;
			}
	

			break;
			break;
		}
	case(SB_THUMBPOSITION):
		{
			pDoc->current_rom_position=nPos/4;

		break;
		}
	case(SB_THUMBTRACK):
		{
			pDoc->current_rom_position=nPos/4;

			break;
		}
	default:
		break;
	}
	
//	CScrollView::OnVScroll(nSBCode, 0, pScrollBar);
	pDoc->UpdateAllViews(NULL);
}

void CDisasmView::OnFormatRawascii() 
{
	CDisasmDoc* pDoc = GetDocument();
	view_type=view_ascii;
		pDoc->UpdateAllViews(NULL);
	
}

void CDisasmView::OnFormatImage16bitspixel1of65536colors() 
{
	CDisasmDoc* pDoc = GetDocument();
	view_type=view_image;
	image_type=image_16bit;
		pDoc->UpdateAllViews(NULL);

	
}

void CDisasmView::OnFormatImage8bitspixel() 
{
	CDisasmDoc* pDoc = GetDocument();
	view_type=view_image;
	image_type=image_8bit;
	pDoc->UpdateAllViews(NULL);

}

void CDisasmView::OnUpdateFormatImage16bitspixel1of65536colors(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((view_type==view_image)&&(image_type==image_16bit));

	
}

void CDisasmView::OnUpdateFormatImage8bitspixel(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((view_type==view_image)&&(image_type==image_8bit));
	
}

void CDisasmView::OnUpdateFormatRawascii(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((view_type==view_ascii));

	
}

void CDisasmView::OnUpdateFormatDisassembly(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((view_type==view_disasm));
	
}

void CDisasmView::OnFormatImage24bitspixel1bytergb() 
{
	CDisasmDoc* pDoc = GetDocument();
	view_type=view_image;
	image_type=image_24bit;
	pDoc->UpdateAllViews(NULL);
	
}

void CDisasmView::OnUpdateFormatImage24bitspixel1bytergb(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((view_type==view_image)&&(image_type==image_24bit));
	
}

void CDisasmView::OnFormatImage15bitspixel5bitrgbunpacked() 
{
	CDisasmDoc* pDoc = GetDocument();
	view_type=view_image;
	image_type=image_15bit;
	pDoc->UpdateAllViews(NULL);
	
}

void CDisasmView::OnUpdateFormatImage15bitspixel5bitrgbunpacked(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((view_type==view_image)&&(image_type==image_15bit));
	
}

void CDisasmView::OnFormatImage18bitspixel6bitrgbunpacked() 
{
	CDisasmDoc* pDoc = GetDocument();
	view_type=view_image;
	image_type=image_18bit;
	pDoc->UpdateAllViews(NULL);
	
}

void CDisasmView::OnUpdateFormatImage18bitspixel6bitrgbunpacked(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((view_type==view_image)&&(image_type==image_18bit));
	
}

void CDisasmView::OnFormatImage21bitspixel7bitrgbunpacked() 
{
	CDisasmDoc* pDoc = GetDocument();
	view_type=view_image;
	image_type=image_21bit;
	pDoc->UpdateAllViews(NULL);
	
}

void CDisasmView::OnUpdateFormatImage21bitspixel7bitrgbunpacked(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((view_type==view_image)&&(image_type==image_21bit));
	
}

void CDisasmView::OnFormatRawhex() 
{
	CDisasmDoc* pDoc = GetDocument();
	view_type=view_hex;
	pDoc->UpdateAllViews(NULL);

	
}

void CDisasmView::OnUpdateFormatRawhex(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((view_type==view_hex));
	
}

void CDisasmView::OnFormatImage15bitpackedrgbn64uncompressed() 
{
	CDisasmDoc* pDoc = GetDocument();
	view_type=view_image;
	image_type=image_15bitpacked;
	pDoc->UpdateAllViews(NULL);
	
}

void CDisasmView::OnUpdateFormatImage15bitpackedrgbn64uncompressed(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((view_type==view_image)&&(image_type==image_15bitpacked));
	
}

void CDisasmView::OnFormatZoom1x() 
{	CDisasmDoc* pDoc = GetDocument();
	pDoc->UpdateAllViews(NULL);

zoomfactor=1;	
}

void CDisasmView::OnUpdateFormatZoom1x(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((zoomfactor==1));
	
}

void CDisasmView::OnFormatZoom2x() 
{	CDisasmDoc* pDoc = GetDocument();
	pDoc->UpdateAllViews(NULL);

zoomfactor=2;	
	
}

void CDisasmView::OnUpdateFormatZoom2x(CCmdUI* pCmdUI) 
{
	
	pCmdUI->SetCheck((zoomfactor==2));
	
}

void CDisasmView::OnFormatZoom4x() 
{	CDisasmDoc* pDoc = GetDocument();
	pDoc->UpdateAllViews(NULL);

zoomfactor=4;	
	
}

void CDisasmView::OnUpdateFormatZoom4x(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((zoomfactor==4));
	
}

void CDisasmView::OnFormatZoom8x() 
{	CDisasmDoc* pDoc = GetDocument();
	pDoc->UpdateAllViews(NULL);

zoomfactor=8;	
	
}

void CDisasmView::OnUpdateFormatZoom8x(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((zoomfactor==8));
	
}

void CDisasmView::OnSoundPlay() 
{

	WAVEFORMATEX myformat;
	WAVEHDR myheader;
	CDisasmDoc* pDoc = GetDocument();
MMRESULT result;
	LPHWAVEOUT phwo;
	char *buff;
	DWORD x,sndlen,y;

	buff=new char[sound_length*sound_channels*(sound_bitsperchannel/8)];


y=0;
	for(x=0;((x+pDoc->current_rom_position*4)<(pDoc->romsize))&&(x<(sound_length*sound_channels*(sound_bitsperchannel/8)));x++)
	{
		
	
		if(x%9)
		{
			buff[y]=pDoc->GetByte(x)-(128*sound_signed);
			y++;
		}
	
	}

	sndlen=y;




phwo=new HWAVEOUT;
 
	myformat.wFormatTag=WAVE_FORMAT_PCM;
	myformat.nChannels=sound_channels;
	myformat.nSamplesPerSec=sound_rate;
	myformat.nAvgBytesPerSec=sound_rate*(sound_bitsperchannel/8)*sound_channels;
	myformat.nBlockAlign=sound_channels*sound_bitsperchannel/8;
	myformat.wBitsPerSample=sound_bitsperchannel;
	myformat.cbSize=0;

result=waveOutOpen(NULL,WAVE_MAPPER,&myformat,NULL,NULL,WAVE_FORMAT_QUERY);


	 result=waveOutOpen(phwo,WAVE_MAPPER,&myformat,NULL,NULL,CALLBACK_NULL);

		myheader.lpData=buff;
		myheader.dwBufferLength=sndlen;
		myheader.dwBytesRecorded=0;
		myheader.dwUser=NULL;
		myheader.dwFlags=WHDR_BEGINLOOP|WHDR_ENDLOOP;
		myheader.dwLoops=1;

		result=waveOutPrepareHeader(*phwo,&myheader,sizeof(WAVEHDR));

		if(result==MMSYSERR_NOERROR)
		{
			waveOutWrite(*phwo,&myheader,sizeof(WAVEHDR));
		}

	

	
		while((waveOutClose(*phwo)==WAVERR_STILLPLAYING));



delete phwo;

delete [] buff;
	





}

void CDisasmView::OnSound22khz() 
{
sound_rate=22050;	
}

void CDisasmView::OnUpdateSound22khz(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((sound_rate==22050));
	
}

void CDisasmView::OnSound11khz() 
{
sound_rate=8000;	
	
}

void CDisasmView::OnUpdateSound11khz(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((sound_rate==8000));
	
}

void CDisasmView::OnSound44khz() 
{
sound_rate=44100;	
	
}

void CDisasmView::OnUpdateSound44khz(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((sound_rate==44100));
	
}

void CDisasmView::OnSoundMono() 
{
	sound_channels=mono;
}

void CDisasmView::OnUpdateSoundMono(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((sound_channels==mono));
	
}

void CDisasmView::OnSoundStereo() 
{
	sound_channels=stereo;	
}

void CDisasmView::OnUpdateSoundStereo(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((sound_channels==stereo));
	
}

void CDisasmView::OnSoundPlaylength100000samples() 
{
sound_length=100000;	
}

void CDisasmView::OnUpdateSoundPlaylength100000samples(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((sound_length==100000));
	
}

void CDisasmView::OnSoundPlaylength10000samples() 
{
sound_length=10000;	
	
}

void CDisasmView::OnUpdateSoundPlaylength10000samples(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((sound_length==10000));
	
}

void CDisasmView::OnSoundPlaylength1msamples() 
{
	sound_length=1000000;	

}

void CDisasmView::OnUpdateSoundPlaylength1msamples(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((sound_length==1000000));
	
}

void CDisasmView::OnSoundBitspersample8() 
{
sound_bitsperchannel=8;
	
}

void CDisasmView::OnUpdateSoundBitspersample8(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((sound_bitsperchannel==8));
	
}

void CDisasmView::OnSoundBitspersample16() 
{
sound_bitsperchannel=16;
	
}

void CDisasmView::OnUpdateSoundBitspersample16(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((sound_bitsperchannel==16));
	
}

void CDisasmView::OnSoundSignedunsignedwrap() 
{
sound_signed^=1;	
}

void CDisasmView::OnUpdateSoundSignedunsignedwrap(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((sound_signed==1));
	
}



void CDisasmView::OnFormatWaveform() 
{
view_type=view_waveform;	
	CDisasmDoc* pDoc = GetDocument();
	pDoc->UpdateAllViews(NULL);
}

void CDisasmView::OnUpdateFormatWaveform(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck((view_type==view_waveform));
	
}

void CDisasmView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{


	if(nChar==0xa0/4)
	{
		OnVScroll(SB_LINEDOWN,0,0);
	}
	if(nChar==0x98/4)
	{
		OnVScroll(SB_LINEUP,0,0);
	}
	if(nChar==0x84/4)
	{
		OnVScroll(SB_PAGEUP,0,0);
	}
	if(nChar==0x88/4)
	{
		OnVScroll(SB_PAGEDOWN,0,0);
	}


	
//	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}
