/* Source code released into the public domain 05-03-97
 Please feel free to improve on this work, Just give me credit
 'Jovis' for the base code. This is for the overall betterment of
 the n64 scene, as we all know it is beginning to kick some 
 major ass. I would suggest that we all donate our knowledge in
 this way, to help everyone and get some really kick-ass stuff,
 rather than squabble over who made what first :).
 BTW i will be moving on to bios-upgrades and possibly hardware
 mods to your doctor to make a realtime tracer/debugger/development
 tool we can all use! Have fun with this, and give your knowledge
 freely too!!! :)
 */

// disasmView.h : interface of the CDisasmView class
//
/////////////////////////////////////////////////////////////////////////////
#define view_disasm 0x0
#define view_ascii 0x1
#define view_hex 0x2
#define view_hexedit 0x3
#define view_image 0x4
#define view_waveform 0x5
#define image_8bit 1
#define image_21bit 2
#define image_15bit 3
#define image_16bit 4
#define image_18bit 5
#define image_24bit 6
#define image_15bitpacked 7
#define mono 1
#define stereo 2
#include <mmsystem.h>




class CDisasmView : public CView
{
protected: // create from serialization only
	CDisasmView();
	DECLARE_DYNCREATE(CDisasmView)

// Attributes
public:

	CDisasmDoc* GetDocument();
	BYTE view_type;
	BYTE image_type;
	BYTE zoomfactor;
	DWORD sound_rate;
	DWORD sound_length;
	WORD sound_channels;
	BYTE sound_bitsperchannel;
	BYTE sound_signed;





// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDisasmView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDisasmView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CDisasmView)
	afx_msg void OnFormatDisassembly();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnFormatRawascii();
	afx_msg void OnFormatImage16bitspixel1of65536colors();
	afx_msg void OnFormatImage8bitspixel();
	afx_msg void OnUpdateFormatImage16bitspixel1of65536colors(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFormatImage8bitspixel(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFormatRawascii(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFormatDisassembly(CCmdUI* pCmdUI);
	afx_msg void OnFormatImage24bitspixel1bytergb();
	afx_msg void OnUpdateFormatImage24bitspixel1bytergb(CCmdUI* pCmdUI);
	afx_msg void OnFormatImage15bitspixel5bitrgbunpacked();
	afx_msg void OnUpdateFormatImage15bitspixel5bitrgbunpacked(CCmdUI* pCmdUI);
	afx_msg void OnFormatImage18bitspixel6bitrgbunpacked();
	afx_msg void OnUpdateFormatImage18bitspixel6bitrgbunpacked(CCmdUI* pCmdUI);
	afx_msg void OnFormatImage21bitspixel7bitrgbunpacked();
	afx_msg void OnUpdateFormatImage21bitspixel7bitrgbunpacked(CCmdUI* pCmdUI);
	afx_msg void OnFormatRawhex();
	afx_msg void OnUpdateFormatRawhex(CCmdUI* pCmdUI);
	afx_msg void OnFormatImage15bitpackedrgbn64uncompressed();
	afx_msg void OnUpdateFormatImage15bitpackedrgbn64uncompressed(CCmdUI* pCmdUI);
	afx_msg void OnFormatZoom1x();
	afx_msg void OnUpdateFormatZoom1x(CCmdUI* pCmdUI);
	afx_msg void OnFormatZoom2x();
	afx_msg void OnUpdateFormatZoom2x(CCmdUI* pCmdUI);
	afx_msg void OnFormatZoom4x();
	afx_msg void OnUpdateFormatZoom4x(CCmdUI* pCmdUI);
	afx_msg void OnFormatZoom8x();
	afx_msg void OnUpdateFormatZoom8x(CCmdUI* pCmdUI);
	afx_msg void OnSoundPlay();
	afx_msg void OnSound22khz();
	afx_msg void OnUpdateSound22khz(CCmdUI* pCmdUI);
	afx_msg void OnSound11khz();
	afx_msg void OnUpdateSound11khz(CCmdUI* pCmdUI);
	afx_msg void OnSound44khz();
	afx_msg void OnUpdateSound44khz(CCmdUI* pCmdUI);
	afx_msg void OnSoundMono();
	afx_msg void OnUpdateSoundMono(CCmdUI* pCmdUI);
	afx_msg void OnSoundStereo();
	afx_msg void OnUpdateSoundStereo(CCmdUI* pCmdUI);
	afx_msg void OnSoundPlaylength100000samples();
	afx_msg void OnUpdateSoundPlaylength100000samples(CCmdUI* pCmdUI);
	afx_msg void OnSoundPlaylength10000samples();
	afx_msg void OnUpdateSoundPlaylength10000samples(CCmdUI* pCmdUI);
	afx_msg void OnSoundPlaylength1msamples();
	afx_msg void OnUpdateSoundPlaylength1msamples(CCmdUI* pCmdUI);
	afx_msg void OnSoundBitspersample8();
	afx_msg void OnUpdateSoundBitspersample8(CCmdUI* pCmdUI);
	afx_msg void OnSoundBitspersample16();
	afx_msg void OnUpdateSoundBitspersample16(CCmdUI* pCmdUI);
	afx_msg void OnSoundSignedunsignedwrap();
	afx_msg void OnUpdateSoundSignedunsignedwrap(CCmdUI* pCmdUI);
	afx_msg void OnFormatWaveform();
	afx_msg void OnUpdateFormatWaveform(CCmdUI* pCmdUI);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in disasmView.cpp
inline CDisasmDoc* CDisasmView::GetDocument()
   { return (CDisasmDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
